Loading...
Searching...
No Matches
juce::AsyncUpdater Class Referenceabstract

## Detailed Description

Has a callback method that is triggered asynchronously.

This object allows an asynchronous callback function to be triggered, for tasks such as coalescing multiple updates into a single callback later on.

Basically, one or more calls to the triggerAsyncUpdate() will result in the message thread calling handleAsyncUpdate() as soon as it can.

The documentation for this class was generated from the following file:

- juce_events/broadcasters/juce_AsyncUpdater.h

Inheritance diagram for juce::AsyncUpdater:

## Public Member Functions

| AsyncUpdater ()
| Creates an AsyncUpdater object.
virtual | ~AsyncUpdater ()
| Destructor.
void | triggerAsyncUpdate ()
| Causes the callback to be triggered at a later time.
void | cancelPendingUpdate () noexcept
| This will stop any pending updates from happening.
void | handleUpdateNowIfNeeded ()
| If an update has been triggered and is pending, this will invoke it synchronously.
bool | isUpdatePending () const noexcept
| Returns true if there's an update callback in the pipeline.
virtual void | handleAsyncUpdate ()=0
| Called back to do whatever your class needs to do.

## Constructors and Destructors

## AsyncUpdater()

juce::AsyncUpdater::AsyncUpdater | ( |  | ) |

Creates an AsyncUpdater object.

Referenced by handleAsyncUpdate().

## ~AsyncUpdater()

virtual juce::AsyncUpdater::~AsyncUpdater | ( |  | ) |

virtual

Destructor.

If there are any pending callbacks when the object is deleted, these are lost.

## Member Functions

## triggerAsyncUpdate()

void juce::AsyncUpdater::triggerAsyncUpdate | ( |  | ) |

Causes the callback to be triggered at a later time.

This method returns immediately, after which a callback to the handleAsyncUpdate() method will be made by the message thread as soon as possible.

If an update callback is already pending but hasn't happened yet, calling this method will have no effect.

It's thread-safe to call this method from any thread, BUT beware of calling it from a real-time (e.g. audio) thread, because it involves posting a message to the system queue, which means it may block (and in general will do on most OSes).

## cancelPendingUpdate()

void juce::AsyncUpdater::cancelPendingUpdate | ( |  | ) |

noexcept

This will stop any pending updates from happening.

If called after triggerAsyncUpdate() and before the handleAsyncUpdate() callback happens, this will cancel the handleAsyncUpdate() callback.

Note that this method simply cancels the next callback - if a callback is already in progress on a different thread, this won't block until the callback finishes, so there's no guarantee that the callback isn't still running when the method returns.

Referenced by juce::NSViewComponentWithParent::~NSViewComponentWithParent().

## handleUpdateNowIfNeeded()

void juce::AsyncUpdater::handleUpdateNowIfNeeded | ( |  | ) |

If an update has been triggered and is pending, this will invoke it synchronously.

Use this as a kind of "flush" operation - if an update is pending, the handleAsyncUpdate() method will be called immediately; if no update is pending, then nothing will be done.

Because this may invoke the callback, this method must only be called on the main event thread.

References handleUpdateNowIfNeeded().

Referenced by handleUpdateNowIfNeeded().

## isUpdatePending()

bool juce::AsyncUpdater::isUpdatePending | ( |  | ) | const

noexcept

Returns true if there's an update callback in the pipeline.

References isUpdatePending().

Referenced by isUpdatePending().

## handleAsyncUpdate()

virtual void juce::AsyncUpdater::handleAsyncUpdate | ( |  | ) |

pure virtual

Called back to do whatever your class needs to do.

This method is called by the message thread at the next convenient time after the triggerAsyncUpdate() method has been called.

Implemented in juce::ComboBox, juce::MenuBarModel, and juce::ModalComponentManager.

References AsyncUpdater(), handleAsyncUpdate(), and JUCE_DECLARE_NON_COPYABLE_WITH_LEAK_DETECTOR.

Referenced by handleAsyncUpdate().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited